package xpctest;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.transaction.TransactionSynchronizationRegistry;

public abstract class AbstractBean 
{
	@Resource(mappedName="java:comp/TransactionSynchronizationRegistry")
	TransactionSynchronizationRegistry tsr;
	
	public abstract EntityManager getEntityManager();
	
	public String helloWorld(String name)
	{
		StringBuilder sb = new StringBuilder("Hello ");
		sb.append(name);
		sb.append(", this is " + this);
		
		EntityManager em = getEntityManager();
		
		sb.append(" (em=");
		sb.append(em);
		sb.append(", identityHashCode=");
		sb.append(System.identityHashCode(em));
		sb.append(", flushMode=");
		sb.append(em.getFlushMode());
		
		Object tx;
		try {
			tx = tsr.getTransactionKey();
		} catch (Exception e) {
			tx = null;
		}
		
		sb.append(", tx=");
		sb.append(tx);
		
		sb.append(")");
		
		return sb.toString();
	}
}
