package main;

import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import xpctest.TestBean;

public class Main {
	public static void main(String[] args) throws Exception
	{
		InitialContext ctx = new InitialContext();

		TestBean testXPCSFSB1a = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestXPCSFSB1!xpctest.TestBeanXPCSFSB1");
		TestBean testXPCSFSB1b = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestXPCSFSB1!xpctest.TestBeanXPCSFSB1");
		TestBean testXPCSFSB2a = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestXPCSFSB2!xpctest.TestBeanXPCSFSB2");
		TestBean testXPCSFSB2b = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestXPCSFSB2!xpctest.TestBeanXPCSFSB2");
	    TestBean testTPCSFSB1a = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestTPCSFSB1!xpctest.TestBeanTPCSFSB1");
	    TestBean testTPCSFSB1b = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestTPCSFSB1!xpctest.TestBeanTPCSFSB1");
	    TestBean testTPCSFSB2a = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestTPCSFSB2!xpctest.TestBeanTPCSFSB2");
	    TestBean testTPCSFSB2b = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestTPCSFSB2!xpctest.TestBeanTPCSFSB2");
	    TestBean testSLSB1a = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestSLSB1!xpctest.TestBeanSLSB1");
	    TestBean testSLSB1b = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestSLSB1!xpctest.TestBeanSLSB1");
	    TestBean testSLSB2a = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestSLSB2!xpctest.TestBeanSLSB2");
	    TestBean testSLSB2b = (TestBean)ctx.lookup("java:global/xpc-glassfish/xpc-glassfish-beans/TestSLSB2!xpctest.TestBeanSLSB2");
		
	    // first, without user transaction
	    System.out.println("Test without user transaction");
	    System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));
	    System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    System.out.println(testXPCSFSB1b.helloWorld("testXPCSFSB1b"));
	    System.out.println(testXPCSFSB2a.helloWorld("testXPCSFSB2a"));
	    System.out.println(testXPCSFSB2b.helloWorld("testXPCSFSB2b"));

	    // now the same, but with user transaction
        UserTransaction ut = (UserTransaction)ctx.lookup("java:comp/UserTransaction");

	    ut.begin();
					
	    System.out.println("\nTest with user transaction " + ut);
	    System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    System.out.println(testXPCSFSB1b.helloWorld("testXPCSFSB1b"));
	    System.out.println(testXPCSFSB2a.helloWorld("testXPCSFSB2a"));
	    System.out.println(testXPCSFSB2b.helloWorld("testXPCSFSB2b"));
	    System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));

	    ut.rollback();

	    ut.begin();
		
	    System.out.println("\nFailed test with user transaction " + ut);
	    System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));
	    // the next line gives us an exception...
	    System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));

	    ut.rollback();

	    ctx.close();
	}
}