package xpctest;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.transaction.Transaction;
import javax.transaction.TransactionManager;

import org.hibernate.Session;

public abstract class AbstractBean 
{
	@Resource(mappedName="java:TransactionManager")
	TransactionManager transactionManager;
	
	public abstract EntityManager getEntityManager();
	
	public String helloWorld(String name)
	{
		StringBuilder sb = new StringBuilder("Hello ");
		sb.append(name);
		sb.append(", this is " + this);
		
		EntityManager em = getEntityManager();
		
		sb.append(" (em=");
		sb.append(em);
		sb.append(", identityHashCode=");
		sb.append(System.identityHashCode(em));
		sb.append(", flushMode=");
		sb.append(em.getFlushMode());
		
		Transaction tx;
		try {
			tx = transactionManager.getTransaction();
		} catch (Exception e) {
			tx = null;
		}
		
		sb.append(", tx=");
		sb.append(tx);
		
		Session session = (Session)em.getDelegate();
		sb.append(", session=#");
		sb.append(System.identityHashCode(session));
		sb.append(")");
		
		return sb.toString();
	}
}
